package socialnetworkservicelogic

import (
	"context"
	"fmt"

	"app-cloudep-tweeting-service/gen_result/pb/tweeting"
	"app-cloudep-tweeting-service/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type AddUserToNetworkLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewAddUserToNetworkLogic(ctx context.Context, svcCtx *svc.ServiceContext) *AddUserToNetworkLogic {
	return &AddUserToNetworkLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *AddUserToNetworkLogic) AddUserToNetwork(in *tweeting.AddUserToNetworkReq) (*tweeting.OKResp, error) {
	// todo: add your logic here and delete this line
	err := l.svcCtx.SocialNetworkRepository.CreateUserNode(l.ctx, in.GetUid())
	if err != nil {
		return nil, err
	}
	fmt.Println(err)

	return &tweeting.OKResp{}, nil
}
